commit 6db837a5288ee3ca5ec504fbd5a765817e556ac2
Author: Marek Polacek <polacek@redhat.com>
Date:   Sun Apr 5 20:31:56 2020 -0400

    c++: Fix ICE with lambda in operator function [PR93597]
    
    If we are going to use get_first_fn let's make sure we operate on
    is_overloaded_fn, as the rest of the codebase does, and if lookup finds
    any class-scope declaration, return early too.
    
            PR c++/93597 - ICE with lambda in operator function.
            * name-lookup.c (maybe_save_operator_binding): Check is_overloaded_fn.
    
            * g++.dg/cpp0x/lambda/lambda-93597.C: New test.

diff --git a/gcc/cp/ChangeLog b/gcc/cp/ChangeLog
index 5c49b2c67e8..2e247069b96 100644
--- a/gcc/cp/ChangeLog
+++ b/gcc/cp/ChangeLog
@@ -1,3 +1,11 @@
+2020-04-05  Marek Polacek  <polacek@redhat.com>
+
+	2020-02-06  Marek Polacek  <polacek@redhat.com>
+	Backport from mainline
+
+	PR c++/93597 - ICE with lambda in operator function.
+	* name-lookup.c (maybe_save_operator_binding): Check is_overloaded_fn.
+
 2020-04-04  Jason Merrill  <jason@redhat.com>
 
 	PR c++/91377
diff --git a/gcc/cp/name-lookup.c b/gcc/cp/name-lookup.c
index 8298ee171e0..f5535ba50bc 100644
--- a/gcc/cp/name-lookup.c
+++ b/gcc/cp/name-lookup.c
@@ -7627,10 +7627,10 @@ maybe_save_operator_binding (tree e)
 
   if (!fns && (fns = op_unqualified_lookup (fnname)))
     {
-      tree fn = get_first_fn (fns);
-      if (DECL_CLASS_SCOPE_P (fn))
-	/* We don't need to remember class-scope functions, normal unqualified
-	   lookup will find them again.  */
+      tree d = is_overloaded_fn (fns) ? get_first_fn (fns) : fns;
+      if (DECL_P (d) && DECL_CLASS_SCOPE_P (d))
+	/* We don't need to remember class-scope functions or declarations,
+	   normal unqualified lookup will find them again.  */
 	return;
 
       bindings = tree_cons (fnname, fns, bindings);
diff --git a/gcc/testsuite/ChangeLog b/gcc/testsuite/ChangeLog
index a1101ae50b5..ab5f3b16775 100644
--- a/gcc/testsuite/ChangeLog
+++ b/gcc/testsuite/ChangeLog
@@ -1,3 +1,11 @@
+2020-04-05  Marek Polacek  <polacek@redhat.com>
+
+	2020-02-06  Marek Polacek  <polacek@redhat.com>
+	Backport from mainline
+
+	PR c++/93597 - ICE with lambda in operator function.
+	* g++.dg/cpp0x/lambda/lambda-93597.C: New test.
+
 2020-04-02  Martin Jambor  <mjambor@suse.cz>
 
 	PR tree-optimization/93435
diff --git a/gcc/testsuite/g++.dg/cpp0x/lambda/lambda-93597.C b/gcc/testsuite/g++.dg/cpp0x/lambda/lambda-93597.C
new file mode 100644
index 00000000000..257d9c7cdfd
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp0x/lambda/lambda-93597.C
@@ -0,0 +1,8 @@
+// PR c++/93597 - ICE with lambda in operator function.
+// { dg-do compile { target c++11 } }
+
+template <typename T>
+struct S {
+  using T ::operator<;
+  void operator==(T x) { [x] { 0 < x; }; }
+};

